#ifndef STRUCTURES_SYSTEMES_H
#define STRUCTURES_SYSTEMES_H

#include "systypes.h"

typedef struct VTOC {
	octet	rien1;
	TS	catalog;
#define PISTE_CATALOG	0x11
#define DEBUT_CATALOG_S	0x0f
#define FIN_CATALOG_S	0x01
	octet	version;
#define VERSION_DOS	3
	mot	rien2;
	octet	volume;
	octet	rien3[0x26-0x07+1];
	octet	n_ts;
#define TS_PAR_TSL	0x7e
	octet	rien4[0x2F-0x28+1];
	octet	piste_allocation;
	octet	sens_allocation;
	mot	rien5;
	octet	np;
	octet	ns;
	mot	no;
	mot	bitmap[N_PISTES][2];
#define BIT_A_0(m,bn)		((m)&= ~(mot)(1<<(bn)))
#define BIT_A_1(m,bn)		((m)|= 1<<(bn))
#define LIBERE_BLOC(b,a)	BIT_A_1((b)[(a).piste][0],(a).secteur)
#define PRENDS_BLOC(b,a)	BIT_A_0((b)[(a).piste][0],(a).secteur)
#define BLOC_LIBRE(b,a)		(((b)[(a).piste][0])&(1<<(a).secteur))
#define PISTE_LIBRE		0xffff
#define PISTE_OCCUPEE		0x0000
	octet	rien[0xFF-0xC5+1];
} VTOC;

typedef struct Fichier	{
	TS	tsl;
	octet	type;
#define FICHIER_TEXTE		0x00
#define FICHIER_BASIC		0x01
#define FICHIER_APLESOFT	0x02
#define FICHIER_BINAIRE		0x04
#define FICHIER_TYPE_S		0x08
#define FICHIER_RELOGEABLE	0x10
#define BIT_VERROUILLAGE	0x80
#define EST_VERROUILLE(f)	((f).type&BIT_VERROUILLAGE)
#define VERROUILLE(f)		((f).type|=BIT_VERROUILLAGE)
#define DEVERROUILLE(f)		((f).type&=~BIT_VERROUILLAGE)

#define LONGUEUR_NOM		31
	octet	nom[LONGUEUR_NOM];
#define FICHIER_LIBRE(f)	((f).nom[0]=='\0')
#define LIBERE_FICHIER(f)	((f).nom[0]='\0')
	mot	taille;
} Fichier;

typedef struct Catalog {
	octet		rien1;
	TS		suivant;
/* #define PISTE_CATALOG	0x11	/* Deja defini dans la VTOC */
	octet		rien2;
#define FICHIERS_PAR_CATALOG	7
	struct Fichier	fichier[FICHIERS_PAR_CATALOG];
} Catalog;

#define MAXIMUM_FICHIER	10
#define TAILLE_SECTEUR	N_OCTETS
#define MAX_PISTES	N_PISTES
#define MAX_SECTEURS	N_SECTEURS
#define PISTE_VTOC	PISTE_CATALOG
#define SECTEUR_VTOC	0

typedef struct TSL {
	octet		rien1;
	TS		suivant;
	octet		rien2[3];
	TS		ts[TS_PAR_TSL];
} TSL;

typedef octet		Secteur[256];

#endif STRUCTURES_SYSTEMES_H
